unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TMainForm = class(TForm)
    BXDirectories: TGroupBox;
    DirectoryBox: TListBox;
    BAddDir: TButton;
    BDelDir: TButton;
    BDirRec: TButton;
    BXSize: TGroupBox;
    CBAutoSize: TRadioButton;
    CBFixedSize: TRadioButton;
    EFixedX: TEdit;
    EFixedY: TEdit;
    LFixedSep: TLabel;
    BChangeNow: TButton;
    BClose: TButton;
    BXMisc: TGroupBox;
    EDestFile: TEdit;
    LDestFile: TLabel;
    CBEverytime: TCheckBox;
    OpenDir: TOpenDialog;
    Bevel1: TBevel;
    LAspectRatio: TLabel;
    PAspectRatio: TPanel;
    ARIs43: TRadioButton;
    ARIs169: TRadioButton;
    ARCustom: TRadioButton;
    EAspectRatio: TEdit;
    LToOne: TLabel;
    Bevel2: TBevel;
    LAutoZoom: TLabel;
    LAZExplanation1: TLabel;
    LAZExplanation2: TLabel;
    LAZMaxDeviation: TLabel;
    CAutoZoom: TTrackBar;
    LAZ0: TLabel;
    LAZNoAZ: TLabel;
    LAZ100: TLabel;
    procedure BCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure AutoSizeChange(Sender: TObject);
    procedure BAddDirClick(Sender: TObject);
    procedure BDirRecClick(Sender: TObject);
    procedure BDelDirClick(Sender: TObject);
    procedure DirectoryBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure BChangeNowClick(Sender: TObject);
    procedure AspectRatioChange(Sender: TObject);
    procedure ARIs43Click(Sender: TObject);
    procedure ARIs169Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation
uses ConfigMgr, Core;

{$R *.dfm}

procedure TMainForm.BCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  ConfigToForm;
end;

procedure TMainForm.FormHide(Sender: TObject);
begin
  FormToConfig;
  SaveConfig;
end;

procedure TMainForm.AutoSizeChange(Sender: TObject);
var B:boolean;
begin
  B:=CBFixedSize.Checked;
  EFixedX.Enabled:=B;
  EFixedY.Enabled:=B;
end;

procedure TMainForm.BAddDirClick(Sender: TObject);
begin
  if not OpenDir.Execute then exit;
  DirectoryBox.Items.Add(
    '-'+ExcludeTrailingPathDelimiter(ExtractFilePath(OpenDir.FileName)));
  DirectoryBox.ItemIndex:=DirectoryBox.Items.Count-1;
end;

procedure TMainForm.BDirRecClick(Sender: TObject);
var i:integer; s:string;
begin
  i:=DirectoryBox.ItemIndex;
  if i<0 then exit;
  s:=DirectoryBox.Items[i];
  if s[1]='+' then DirectoryBox.Items[i]:='-'+copy(s,2,length(s)-1)
              else DirectoryBox.Items[i]:='+'+copy(s,2,length(s)-1);
end;

procedure TMainForm.BDelDirClick(Sender: TObject);
var i:integer;
begin
  i:=DirectoryBox.ItemIndex;
  if i<0 then exit;
  DirectoryBox.Items.Delete(i);
  if i>=DirectoryBox.Items.Count
    then DirectoryBox.ItemIndex:=DirectoryBox.Items.Count-1
    else DirectoryBox.ItemIndex:=i;
end;

procedure TMainForm.DirectoryBoxDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var s:string;
begin
  with DirectoryBox,Canvas do begin
    FillRect(Rect);
    s:=Items[Index];
    TextOut(Rect.Left+2,Rect.Top+1,copy(s,2,length(s)-1));
    if s[1]='+' then
      TextOut(Rect.Left+5+TextWidth(copy(s,2,length(s)-1)),Rect.Top+1,'(rekursiv)');
  end;
end;

procedure TMainForm.BChangeNowClick(Sender: TObject);
begin
  FormToConfig;
  Cursor:=crHourGlass;
  Application.ProcessMessages;
  DoIt;
  Cursor:=crDefault;
end;

procedure TMainForm.AspectRatioChange(Sender: TObject);
begin
  EAspectRatio.Enabled:=ARCustom.Checked;
end;

procedure TMainForm.ARIs43Click(Sender: TObject);
begin
  EAspectRatio.Enabled:=false;
  EAspectRatio.Text:=FloatToStr(AR43);
end;

procedure TMainForm.ARIs169Click(Sender: TObject);
begin
  EAspectRatio.Enabled:=false;
  EAspectRatio.Text:=FloatToStr(AR169);
end;

end.

